// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from fuse_msgs:srv/SetPoseDeprecated.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "fuse_msgs/srv/set_pose_deprecated.hpp"


#ifndef FUSE_MSGS__SRV__DETAIL__SET_POSE_DEPRECATED__TRAITS_HPP_
#define FUSE_MSGS__SRV__DETAIL__SET_POSE_DEPRECATED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "fuse_msgs/srv/detail/set_pose_deprecated__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_with_covariance_stamped__traits.hpp"

namespace fuse_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetPoseDeprecated_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetPoseDeprecated_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetPoseDeprecated_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace fuse_msgs

namespace rosidl_generator_traits
{

[[deprecated("use fuse_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const fuse_msgs::srv::SetPoseDeprecated_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  fuse_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use fuse_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const fuse_msgs::srv::SetPoseDeprecated_Request & msg)
{
  return fuse_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<fuse_msgs::srv::SetPoseDeprecated_Request>()
{
  return "fuse_msgs::srv::SetPoseDeprecated_Request";
}

template<>
inline const char * name<fuse_msgs::srv::SetPoseDeprecated_Request>()
{
  return "fuse_msgs/srv/SetPoseDeprecated_Request";
}

template<>
struct has_fixed_size<fuse_msgs::srv::SetPoseDeprecated_Request>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::PoseWithCovarianceStamped>::value> {};

template<>
struct has_bounded_size<fuse_msgs::srv::SetPoseDeprecated_Request>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::PoseWithCovarianceStamped>::value> {};

template<>
struct is_message<fuse_msgs::srv::SetPoseDeprecated_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace fuse_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetPoseDeprecated_Response & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetPoseDeprecated_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetPoseDeprecated_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace fuse_msgs

namespace rosidl_generator_traits
{

[[deprecated("use fuse_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const fuse_msgs::srv::SetPoseDeprecated_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  fuse_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use fuse_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const fuse_msgs::srv::SetPoseDeprecated_Response & msg)
{
  return fuse_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<fuse_msgs::srv::SetPoseDeprecated_Response>()
{
  return "fuse_msgs::srv::SetPoseDeprecated_Response";
}

template<>
inline const char * name<fuse_msgs::srv::SetPoseDeprecated_Response>()
{
  return "fuse_msgs/srv/SetPoseDeprecated_Response";
}

template<>
struct has_fixed_size<fuse_msgs::srv::SetPoseDeprecated_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<fuse_msgs::srv::SetPoseDeprecated_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<fuse_msgs::srv::SetPoseDeprecated_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace fuse_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetPoseDeprecated_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetPoseDeprecated_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetPoseDeprecated_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace fuse_msgs

namespace rosidl_generator_traits
{

[[deprecated("use fuse_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const fuse_msgs::srv::SetPoseDeprecated_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  fuse_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use fuse_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const fuse_msgs::srv::SetPoseDeprecated_Event & msg)
{
  return fuse_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<fuse_msgs::srv::SetPoseDeprecated_Event>()
{
  return "fuse_msgs::srv::SetPoseDeprecated_Event";
}

template<>
inline const char * name<fuse_msgs::srv::SetPoseDeprecated_Event>()
{
  return "fuse_msgs/srv/SetPoseDeprecated_Event";
}

template<>
struct has_fixed_size<fuse_msgs::srv::SetPoseDeprecated_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<fuse_msgs::srv::SetPoseDeprecated_Event>
  : std::integral_constant<bool, has_bounded_size<fuse_msgs::srv::SetPoseDeprecated_Request>::value && has_bounded_size<fuse_msgs::srv::SetPoseDeprecated_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<fuse_msgs::srv::SetPoseDeprecated_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<fuse_msgs::srv::SetPoseDeprecated>()
{
  return "fuse_msgs::srv::SetPoseDeprecated";
}

template<>
inline const char * name<fuse_msgs::srv::SetPoseDeprecated>()
{
  return "fuse_msgs/srv/SetPoseDeprecated";
}

template<>
struct has_fixed_size<fuse_msgs::srv::SetPoseDeprecated>
  : std::integral_constant<
    bool,
    has_fixed_size<fuse_msgs::srv::SetPoseDeprecated_Request>::value &&
    has_fixed_size<fuse_msgs::srv::SetPoseDeprecated_Response>::value
  >
{
};

template<>
struct has_bounded_size<fuse_msgs::srv::SetPoseDeprecated>
  : std::integral_constant<
    bool,
    has_bounded_size<fuse_msgs::srv::SetPoseDeprecated_Request>::value &&
    has_bounded_size<fuse_msgs::srv::SetPoseDeprecated_Response>::value
  >
{
};

template<>
struct is_service<fuse_msgs::srv::SetPoseDeprecated>
  : std::true_type
{
};

template<>
struct is_service_request<fuse_msgs::srv::SetPoseDeprecated_Request>
  : std::true_type
{
};

template<>
struct is_service_response<fuse_msgs::srv::SetPoseDeprecated_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // FUSE_MSGS__SRV__DETAIL__SET_POSE_DEPRECATED__TRAITS_HPP_
