// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from fuse_msgs:msg/SerializedGraph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "fuse_msgs/msg/serialized_graph.h"


#ifndef FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__STRUCT_H_
#define FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'plugin_name'
#include "rosidl_runtime_c/string.h"
// Member 'data'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/SerializedGraph in the package fuse_msgs.
typedef struct fuse_msgs__msg__SerializedGraph
{
  /// A timestamp associated with the graph
  std_msgs__msg__Header header;
  /// The fully-qualified name of the plugin used to serialize/deserialize this graph
  rosidl_runtime_c__String plugin_name;
  /// The serialized graph as a raw data buffer
  rosidl_runtime_c__uint8__Sequence data;
} fuse_msgs__msg__SerializedGraph;

// Struct for a sequence of fuse_msgs__msg__SerializedGraph.
typedef struct fuse_msgs__msg__SerializedGraph__Sequence
{
  fuse_msgs__msg__SerializedGraph * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} fuse_msgs__msg__SerializedGraph__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__STRUCT_H_
