// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from fuse_msgs:msg/SerializedGraph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "fuse_msgs/msg/serialized_graph.hpp"


#ifndef FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__TRAITS_HPP_
#define FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "fuse_msgs/msg/detail/serialized_graph__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace fuse_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SerializedGraph & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: plugin_name
  {
    out << "plugin_name: ";
    rosidl_generator_traits::value_to_yaml(msg.plugin_name, out);
    out << ", ";
  }

  // member: data
  {
    if (msg.data.size() == 0) {
      out << "data: []";
    } else {
      out << "data: [";
      size_t pending_items = msg.data.size();
      for (auto item : msg.data) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SerializedGraph & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: plugin_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plugin_name: ";
    rosidl_generator_traits::value_to_yaml(msg.plugin_name, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SerializedGraph & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace fuse_msgs

namespace rosidl_generator_traits
{

[[deprecated("use fuse_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const fuse_msgs::msg::SerializedGraph & msg,
  std::ostream & out, size_t indentation = 0)
{
  fuse_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use fuse_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const fuse_msgs::msg::SerializedGraph & msg)
{
  return fuse_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<fuse_msgs::msg::SerializedGraph>()
{
  return "fuse_msgs::msg::SerializedGraph";
}

template<>
inline const char * name<fuse_msgs::msg::SerializedGraph>()
{
  return "fuse_msgs/msg/SerializedGraph";
}

template<>
struct has_fixed_size<fuse_msgs::msg::SerializedGraph>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<fuse_msgs::msg::SerializedGraph>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<fuse_msgs::msg::SerializedGraph>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__TRAITS_HPP_
