// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from fuse_msgs:srv/SetGraph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "fuse_msgs/srv/set_graph.hpp"


#ifndef FUSE_MSGS__SRV__DETAIL__SET_GRAPH__STRUCT_HPP_
#define FUSE_MSGS__SRV__DETAIL__SET_GRAPH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'graph'
#include "fuse_msgs/msg/detail/serialized_graph__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__fuse_msgs__srv__SetGraph_Request __attribute__((deprecated))
#else
# define DEPRECATED__fuse_msgs__srv__SetGraph_Request __declspec(deprecated)
#endif

namespace fuse_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetGraph_Request_
{
  using Type = SetGraph_Request_<ContainerAllocator>;

  explicit SetGraph_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : graph(_init)
  {
    (void)_init;
  }

  explicit SetGraph_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : graph(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _graph_type =
    fuse_msgs::msg::SerializedGraph_<ContainerAllocator>;
  _graph_type graph;

  // setters for named parameter idiom
  Type & set__graph(
    const fuse_msgs::msg::SerializedGraph_<ContainerAllocator> & _arg)
  {
    this->graph = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    fuse_msgs::srv::SetGraph_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const fuse_msgs::srv::SetGraph_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__fuse_msgs__srv__SetGraph_Request
    std::shared_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__fuse_msgs__srv__SetGraph_Request
    std::shared_ptr<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetGraph_Request_ & other) const
  {
    if (this->graph != other.graph) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetGraph_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetGraph_Request_

// alias to use template instance with default allocator
using SetGraph_Request =
  fuse_msgs::srv::SetGraph_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace fuse_msgs


#ifndef _WIN32
# define DEPRECATED__fuse_msgs__srv__SetGraph_Response __attribute__((deprecated))
#else
# define DEPRECATED__fuse_msgs__srv__SetGraph_Response __declspec(deprecated)
#endif

namespace fuse_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetGraph_Response_
{
  using Type = SetGraph_Response_<ContainerAllocator>;

  explicit SetGraph_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit SetGraph_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    fuse_msgs::srv::SetGraph_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const fuse_msgs::srv::SetGraph_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__fuse_msgs__srv__SetGraph_Response
    std::shared_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__fuse_msgs__srv__SetGraph_Response
    std::shared_ptr<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetGraph_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetGraph_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetGraph_Response_

// alias to use template instance with default allocator
using SetGraph_Response =
  fuse_msgs::srv::SetGraph_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace fuse_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__fuse_msgs__srv__SetGraph_Event __attribute__((deprecated))
#else
# define DEPRECATED__fuse_msgs__srv__SetGraph_Event __declspec(deprecated)
#endif

namespace fuse_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetGraph_Event_
{
  using Type = SetGraph_Event_<ContainerAllocator>;

  explicit SetGraph_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit SetGraph_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<fuse_msgs::srv::SetGraph_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<fuse_msgs::srv::SetGraph_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    fuse_msgs::srv::SetGraph_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const fuse_msgs::srv::SetGraph_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::srv::SetGraph_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::srv::SetGraph_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__fuse_msgs__srv__SetGraph_Event
    std::shared_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__fuse_msgs__srv__SetGraph_Event
    std::shared_ptr<fuse_msgs::srv::SetGraph_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetGraph_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetGraph_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetGraph_Event_

// alias to use template instance with default allocator
using SetGraph_Event =
  fuse_msgs::srv::SetGraph_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace fuse_msgs

namespace fuse_msgs
{

namespace srv
{

struct SetGraph
{
  using Request = fuse_msgs::srv::SetGraph_Request;
  using Response = fuse_msgs::srv::SetGraph_Response;
  using Event = fuse_msgs::srv::SetGraph_Event;
};

}  // namespace srv

}  // namespace fuse_msgs

#endif  // FUSE_MSGS__SRV__DETAIL__SET_GRAPH__STRUCT_HPP_
